commit 479695923c6b79a35ffd5d17971c255a2aeedf7c (HEAD -> checkout_memory_for_cli, shopee/checkout_memory_for_cli)
Author: Zhengzhi Duan <“zhengzhi.duan@shopee.com”>
Date:   Mon May 30 10:04:50 2022 +0800

    fix an memory leak caused by sao_adaptive close

diff --git a/source/encoder/framefilter.cpp b/source/encoder/framefilter.cpp
index 7cb0fad8a..4e2cf91c5 100644
--- a/source/encoder/framefilter.cpp
+++ b/source/encoder/framefilter.cpp
@@ -162,10 +162,11 @@ void FrameFilter::destroy()
 
     if (m_parallelFilter)
     {
-        if (m_useSao)
+        if (m_saoCreated)
         {
             for(int row = 0; row < m_numRows; row++)
                 m_parallelFilter[row].m_sao.destroy((row == 0 ? 1 : 0));
+            m_saoCreated = 0;
         }
 
         delete[] m_parallelFilter;
@@ -178,6 +179,7 @@ void FrameFilter::init(Encoder *top, FrameEncoder *frame, int numRows, uint32_t
     m_param = frame->m_param;
     m_frameEncoder = frame;
     m_useSao = 1;
+    m_saoCreated = 0;
     m_numRows = numRows;
     m_numCols = numCols;
     m_hChromaShift = CHROMA_H_SHIFT(m_param->internalCsp);
@@ -222,6 +224,10 @@ void FrameFilter::init(Encoder *top, FrameEncoder *frame, int numRows, uint32_t
             if (row > 0)
                 m_parallelFilter[row].m_prevRow = &m_parallelFilter[row - 1];
         }
+        if (m_useSao)
+        {
+            m_saoCreated = 1;
+        }
     }
 
 }
diff --git a/source/encoder/framefilter.h b/source/encoder/framefilter.h
index 89b727239..88319addd 100644
--- a/source/encoder/framefilter.h
+++ b/source/encoder/framefilter.h
@@ -47,6 +47,7 @@ public:
     s265_param*   m_param;
     Frame*        m_frame;
     int           m_useSao;
+    bool          m_saoCreated;
     FrameEncoder* m_frameEncoder;
     int           m_hChromaShift;
     int           m_vChromaShift;
